// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//--------------------------------------------------------------------------
//
//                     XMM Science Analysis System (SAS)
//                    (c) 1997-2010 European Space Agency
//
//--------------------------------------------------------------------------
//
//	StandardPointInPolyTest.h:	--- simple point-in-polygon test
//
//	DESCRIPTION:
//		This file contains prototypes of functions for testing whether a
//		point is inside a given closed polygon.
//
//	CHANGE HISTORY:
//		UL, 1998-01-05: 1.0.0: - first version
//		UL, 1999-01-29: 1.1.0: - redundant data member in GeoPoint removed
//
//	AUTHOR:
//		U. Lammers (UL), Wed Aug 27 11:48:12 MET DST 1997
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/selectlib/src/utils/StandardPolygon.h,v 1.1 2001/08/07 14:06:52 ulammers Exp $
//

#ifndef STANDARD_POINT_IN_POLY_TEST_H
#define STANDARD_POINT_IN_POLY_TEST_H

typedef struct { double x; double y; } GeoPoint;
typedef struct { GeoPoint p1; GeoPoint p2; } GeoLine;

namespace StandardPolygon {
//
//	test whether a point lies in a polygon
//
bool insidePolygon(const GeoPoint &p, GeoPoint pl[], unsigned N);

} // insidePolygon()

#endif







