// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	polygontest: check correctness of TriangulatablePolygon class
//
//	UL, Fri Aug  3 14:56:07 MET DST 2001
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/selectlib/test/randpolytest.cc,v 1.2 2002/03/18 18:14:45 ulammers Exp $
//
#include <cassert>
#include <string>
#include <vector>
#include <iostream>
#include "common.h"
#include "Random.h"
#include "TriangulatablePolygon.h"

int main()
{
	std::vector<double> xCoords,
						yCoords;

	randGen.max(100.);
	const unsigned N = 400;
	for (unsigned n=0; n<N; ++n) {
		xCoords.push_back(randGen.rand());
		yCoords.push_back(randGen.rand());
	}

	TriangulatablePolygon poly(xCoords, yCoords, true);
	const PointList<double> &vert = poly.vertices();
	for (unsigned n=0; n<N; ++n)
		std::cout<<vert[n].x()<<' '<<vert[n].y()<<std::endl;

	std::cout<<'&'<<std::endl;
	randGen.max(100.);
	for (unsigned n=0; n<10000; ++n) {
		double x = randGen.rand(),
			   y = randGen.rand();
		std::cerr<<x<<'/'<<y<<" is ";
		bool res = poly.contains(Point<double>(x, y));
		if (res)
			std::cerr<<"in";
		else
			std::cerr<<"out";
		std::cerr<<std::endl;
		if (res)
			std::cout<<x<<' '<<y<<std::endl;
	}

	return 0;
} // main()
