// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include "SetTableColumn.h"
#include <cassert>

int main()
{
	//
	//	create temp data set
	//
	const std::string dsname = "composers.ds",
					  tabname = "MOZART",
					  colname = "MAGICFLUTE";

	DataSet *set = dataSetServer->open(dsname, Dal::Create);

	Table *tab = set->addTable(tabname, 0);
	tab->addColumn(colname, Dal::Bool);

	dataSetServer->close(set);

	std::vector<SetTableColumn *> v;
	v.push_back(new SetTableColumn(dsname));
	v.push_back(new SetTableColumn(dsname + ":"));
	v.push_back(new SetTableColumn(dsname + "+1"));
	v.push_back(new SetTableColumn(dsname + "+" + tabname));
	v.push_back(new SetTableColumn(dsname + "[1]"));
	v.push_back(new SetTableColumn(dsname + "[" + tabname + "]"));
	v.push_back(new SetTableColumn(dsname + ":1"));
	v.push_back(new SetTableColumn(dsname + ":" + tabname));
	v.push_back(new SetTableColumn(dsname + "::"));
	v.push_back(new SetTableColumn(dsname + "::0"));
	v.push_back(new SetTableColumn(dsname + "::" + colname));
	v.push_back(new SetTableColumn(dsname + ":" + tabname + ":" + colname));

	for (unsigned n=0; n<v.size(); ++n)
		assert(v[n]->dataSet()->name() == dsname &&
			   v[n]->table()->name() == tabname &&
			   v[n]->column()->name() == colname);

	SetTableColumn s(dsname + "::" + colname);

	assert(s.column()->name() == colname);

	return 0;
}
